SystemOrganization addCategory: #'Magritte-Seaside-Components'!
SystemOrganization addCategory: #'Magritte-Seaside-Report'!
SystemOrganization addCategory: #'Magritte-Seaside-Renderer'!
SystemOrganization addCategory: #'Magritte-Seaside-Examples'!

!MABooleanDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 22:45'!
defaultComponentClass
	^MACheckboxComponent! !

!MAElementDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:31'!
defaultAttributes
	^Dictionary new.! !

!MAElementDescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:10'!
acceptRenderer: aRenderer
	aRenderer renderElement: self.! !

!MAElementDescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:32'!
attributes
	^self 
		propertyAt: #attributes 
		ifAbsent: [ self class defaultAttributes ].! !

!MAElementDescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
attributes: aDictionary
	^self propertyAt: #attributes put: aDictionary.! !

!MADurationDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/15/2005 21:49'!
defaultComponentClass
	^MADurationInputComponent! !

!MATimeDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATimeInputComponent! !

WAComponent subclass: #MAComponent
	instanceVariableNames: 'model description renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAComponent class methodsFor: 'accessing-defaults' stamp: 'lr 3/14/2005 17:02'!
defaultRenderer
	^MATableRenderer new.! !

!MAComponent class methodsFor: 'class initialization' stamp: 'lr 3/11/2005 15:49'!
initialize
	Sentinel := Object new.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 11/28/2004 19:10'!
model: aModel
	^self model: aModel description: aModel description.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 12/20/2004 20:20'!
model: aModel description: aDescription
	^self model: aModel description: aDescription renderer: self defaultRenderer.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 12/20/2004 18:25'!
model: aModel description: aDescription renderer: aRenderer
	^self new
		model: aModel;
		description: aDescription;
		renderer: aRenderer;
		yourself.! !

!MAComponent methodsFor: 'forms' stamp: 'lr 2/28/2005 16:14'!
addForm
	self addForm: #( save cancel ).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 2/28/2005 16:14'!
addForm: aCollection
	self addDecoration: (WAFormDecoration new 
		buttons: aCollection;
		yourself).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 3/14/2005 11:58'!
addValidatedForm
	self addValidatedForm: #( save cancel ).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 3/14/2005 12:09'!
addValidatedForm: aCollection
	self addDecoration: (WAFormDecoration new 
		buttons: aCollection;
		yourself).
	self addDecoration: (MAValidationDecoration new).! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:08'!
buildComponent: anObject
	^self 
		buildComponent: anObject 
		description: anObject description.! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:27'!
buildComponent: anObject description: aDescription
	^(aDescription asComponentOn: anObject)
		renderer: self renderer;
		yourself.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
cancel
	self answer: nil.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/11/2005 11:46'!
close
	self cancel.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/11/2005 15:44'!
commit! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
description
	^description! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
description: anObject
	description := anObject! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
model
	^model! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
model: anObject
	model := anObject! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 20:40'!
readonly
	^self renderer readonly.! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 23:00'!
readonly: aBoolean
	self renderer readonly: aBoolean.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
refresh! !

!MAComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:13'!
renderContentOn: html
	self renderer
		component: self;
		html: html;
		visit: self description.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/21/2005 20:57'!
renderEditorOn: html 
	self renderViewerOn: html.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 17:08'!
renderLabelOn: html
	self description label isEmptyOrNil ifFalse: [
		html render: self description label; text: ':' ].
	self renderRequiredOn: html.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/22/2005 09:36'!
renderRequiredOn: html 
	(self description isRequired 
		and: [ self description isReadonly not ] 
		and: [ self renderer isReadonly not ])
			ifTrue: [ html spanClass: 'required' with: '*' ].! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/21/2005 20:49'!
renderViewerOn: html ! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/3/2005 16:16'!
renderer
	^renderer! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:08'!
renderer: aRenderer
	renderer := aRenderer! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
reset! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 12:17'!
save
	self validate; commit; answer: self model.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
validate! !

MAComponent subclass: #MAComposedComponent
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAComposedComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:32'!
buildChildren
	^Array streamContents: [ :stream |
		self description do: [ :each |
			each isVisible ifTrue: [
				stream nextPut: (self
					buildComponent: self model 
					description: each) ] ] ].! !

!MAComposedComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:31'!
children
	children isNil
		ifTrue: [ self children: self buildChildren ].
	^children.! !

!MAComposedComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:06'!
children: aCollection
	children := aCollection! !

!MAComposedComponent methodsFor: 'actions' stamp: 'lr 3/15/2005 22:51'!
commit
	self children do: [ :each | each commit ].
	super commit.! !

!MAComposedComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:06'!
refresh
	super refresh.
	self children: nil.! !

!MAComposedComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:48'!
renderViewerOn: html 
	self children do: [ :each | html render: each ].! !

!MAComposedComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:02'!
reset
	super reset.
	self children do: [ :each | each reset ].
! !

!MAComposedComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:02'!
validate
	super validate.
	self children do: [ :each | each validate ].! !

MAComponent subclass: #MAElementComponent
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MAElementComponent subclass: #MACheckboxComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MACheckboxComponent methodsFor: 'private' stamp: 'lr 3/14/2005 17:06'!
renderCheckboxDisabled: aBoolean on: html
	html label: [
		html attributeAt: 'disabled' put: aBoolean.
		html checkboxOn: #cache of: self. 
		html render: self description label ].! !

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/14/2005 17:06'!
renderEditorOn: html
	self renderCheckboxDisabled: false on: html.
	self renderRequiredOn: html.! !

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:07'!
renderLabelOn: html! !

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/14/2005 14:45'!
renderViewerOn: html
	self renderCheckboxDisabled: true on: html.! !

!MAElementComponent methodsFor: 'private' stamp: 'lr 3/15/2005 22:56'!
buildCache
	^self description read: self model.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/12/2005 00:07'!
cache
	cache isNil
		ifTrue: [ self cache: self buildCache ].
	^cache.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/14/2005 16:24'!
cache: anObject
	cache := anObject isString
		ifTrue: [ self description parseString: anObject ]
		ifFalse: [ anObject ].! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 16:24'!
commit
	super commit.
	self description isReadonly 
		ifFalse: [ self description write: cache to: model ].! !

!MAElementComponent methodsFor: 'rendering' stamp: 'lr 3/21/2005 20:50'!
renderViewerOn: html
	html render: self cache.! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/13/2005 17:29'!
reset
	super reset.
	self cache: nil.! !

!MAElementComponent methodsFor: 'private' stamp: 'lr 3/22/2005 09:25'!
showHalo
	^false! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 16:25'!
validate
	super validate.
	self description isReadonly 
		ifFalse: [ self description validate: cache ].! !

MAElementComponent subclass: #MAFileUploadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 3/14/2005 17:07'!
renderEditorOn: html 
	html attributes: self description attributes.
	html fileUploadWithCallback: [ :file | self cache: file ].! !

MAElementComponent subclass: #MARadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MARadioGroupComponent methodsFor: 'rendering' stamp: 'lr 3/11/2005 23:22'!
renderEditorOn: html
	html radioGroup in: [ :group |
		self description options do: [ :each |
			html label: [
				html attributes: self description attributes.
				html 
					radioButtonInGroup: group
					selected: self cache = each
					callback: [ self cache: each ].
				html render: each ] ] ].! !

MAElementComponent subclass: #MASelectListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MASelectListComponent methodsFor: 'rendering' stamp: 'lr 3/16/2005 15:32'!
renderEditorOn: html
	html attributes: self description attributes.
	html 
		selectFromList: self description options
		selected: self cache
		callback: (MessageSend
			receiver: self
			selector: #cache:)
		labels: [ :each | each asLabel ].! !

MAElementComponent subclass: #MATableComponent
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATableComponent methodsFor: 'private' stamp: 'lr 3/15/2005 22:21'!
buildCache
	^(self description read: self model) in: [ :result |
		self fieldCount = result size
			ifFalse: [ Array new: self fieldCount ]
			ifTrue: [ result copy ] ].! !

!MATableComponent methodsFor: 'private' stamp: 'lr 3/16/2005 20:28'!
buildCells
	^self cache collectWithIndex: [ :each :index |
		self description cellDescription copy
			key: index; 
			label: (String streamContents: [ :stream |
				stream 
					nextPutAll: self description label;
					nextPutAll: ' [';
					nextPutAll: (self columnLabels at: (self columnOfIndex: index)); 
					nextPutAll: ', ';
					nextPutAll: (self rowLabels at: (self rowOfIndex: index));
					nextPutAll: ']' ]);
			asComponentOn: self ].	! !

!MATableComponent methodsFor: 'accessing-table' stamp: 'lr 3/15/2005 22:07'!
cacheAt: aRowIndex at: aColIndex
	^self cache at: (self indexAt: aRowIndex at: aColIndex).! !

!MATableComponent methodsFor: 'accessing-table' stamp: 'lr 3/15/2005 22:08'!
cacheAt: aRowIndex at: aColIndex put: anObject
	self cache at: (self indexAt: aRowIndex at: aColIndex) put: anObject.! !

!MATableComponent methodsFor: 'accessing-table' stamp: 'lr 3/15/2005 22:47'!
cellAt: aRowIndex at: aColIndex
	^self cells at: (self indexAt: aRowIndex at: aColIndex).! !

!MATableComponent methodsFor: 'accessing-table' stamp: 'lr 3/15/2005 22:47'!
cellAt: aRowIndex at: aColIndex put: aComponent
	self cells at: (self indexAt: aRowIndex at: aColIndex) put: aComponent.! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:48'!
cells
	cells isNil
		ifTrue: [ self cells: self buildCells ].
	^cells.! !

!MATableComponent methodsFor: 'accessing' stamp: 'lr 3/15/2005 22:48'!
cells: aColleciton
	cells := aColleciton! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:11'!
columnCount
	^self description columnCount.! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:32'!
columnLabels
	^self description columnLabels.! !

!MATableComponent methodsFor: 'private-indexes' stamp: 'lr 3/15/2005 23:14'!
columnOfIndex: anInteger
	| index |
	index := anInteger \\ self columnCount.
	^index isZero
		ifTrue: [ self columnCount ]
		ifFalse: [ index ].! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 3/15/2005 22:51'!
commit
	self cells do: [ :each | each commit ].
	super commit.! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:18'!
fieldCount
	^self rowCount * self columnCount.! !

!MATableComponent methodsFor: 'private-indexes' stamp: 'lr 3/15/2005 23:08'!
indexAt: aRowIndex at: aColIndex
	^aRowIndex - 1 * self columnCount + aColIndex.! !

!MATableComponent methodsFor: 'private-model' stamp: 'lr 3/15/2005 22:41'!
readUsing: aDescription
	^self cache at: aDescription key.! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 3/15/2005 22:59'!
renderEditorOn: html
	self 
		renderTableCells: [ :cell | cell renderEditorOn: html ]
		on: html.! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 3/15/2005 22:59'!
renderTableCells: aBlock on: html
	html table: [
		html tableRow: [
			html tableHeading: nil.
			self columnLabels do: [ :each |
				html tableHeading: each ] ].
		self rowLabels withIndexDo: [ :row :rindex |
			html tableRow: [
				html tableHeading: row.
				self columnLabels withIndexDo: [ :col :cindex |
					html tableData: [ 
						aBlock value: (self cellAt: rindex at: cindex) ] ] ] ] ].! !

!MATableComponent methodsFor: 'rendering' stamp: 'lr 3/15/2005 22:59'!
renderViewerOn: html
	self 
		renderTableCells: [ :cell | cell renderViewerOn: html ]
		on: html.! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 3/15/2005 22:50'!
reset
	super reset.
	self cells: nil.! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:11'!
rowCount
	^self description rowCount.! !

!MATableComponent methodsFor: 'accessing-dynamic' stamp: 'lr 3/15/2005 22:32'!
rowLabels
	^self description rowLabels.! !

!MATableComponent methodsFor: 'private-indexes' stamp: 'lr 3/15/2005 23:15'!
rowOfIndex: anInteger
	^anInteger - 1 // self columnCount + 1.! !

!MATableComponent methodsFor: 'actions' stamp: 'lr 3/18/2005 12:33'!
validate
	self cells do: [ :each | each validate ].
	super validate.! !

!MATableComponent methodsFor: 'private-model' stamp: 'lr 3/15/2005 22:52'!
write: anObject using: aDescription
	^self cache at: aDescription key put: anObject.! !

MAElementComponent subclass: #MATextAreaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:17'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textAreaOn: #cache of: self.! !

MAElementComponent subclass: #MATextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MATextInputComponent subclass: #MADateInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 3/14/2005 16:26'!
renderEditorOn: html
	super renderEditorOn: html.
	html 
		submitButtonWithAction: [ self cache: Date current ]
		text: 'current'.! !

MATextInputComponent subclass: #MADurationInputComponent
	instanceVariableNames: 'start'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADurationInputComponent methodsFor: 'rendering' stamp: 'lr 3/21/2005 20:54'!
renderEditorOn: html
	super renderEditorOn: html.
	html
		submitButtonWithAction: [  
			start := start isNil
				ifTrue: [ TimeStamp current ]
				ifFalse: [ self cache: TimeStamp current - start. nil ] ]
		text: (start isNil ifTrue: [ 'start' ] ifFalse: [ 'stop' ]).! !

!MATextInputComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:33'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textInputOn: #cache of: self.! !

MATextInputComponent subclass: #MATimeInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeInputComponent methodsFor: 'rendering' stamp: 'lr 3/12/2005 00:05'!
renderEditorOn: html
	super renderEditorOn: html.
	html 
		submitButtonWithAction: [ self cache: Time current ]
		text: 'current'.! !

MATextInputComponent subclass: #MATimeStampInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeStampInputComponent methodsFor: 'rendering' stamp: 'lr 3/12/2005 00:05'!
renderEditorOn: html
	super renderEditorOn: html.
	html 
		submitButtonWithAction: [ self cache: TimeStamp current ]
		text: 'current'.! !

MAElementComponent subclass: #MATextPasswordComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextPasswordComponent methodsFor: 'actions' stamp: 'lr 3/14/2005 14:09'!
commit
	(self description isObfuscated: self cache)
		ifFalse: [ super commit ].! !

!MATextPasswordComponent methodsFor: 'accessing' stamp: 'lr 3/11/2005 16:27'!
obfuscated
	^String 
		new: (self cache isNil 
			ifTrue: [ 0 ]
			ifFalse: [ self cache size ])
		withAll: $*.! !

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:25'!
renderEditorOn: html 
	html attributes: self description attributes.
	html 
		passwordInputWithValue: self obfuscated
		callback: (MessageSend 
			receiver: self 
			selector: #cache:).! !

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:24'!
renderViewerOn: html 
	html render: self obfuscated.! !

WAComponent subclass: #MAExampleEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

MAExampleEditor subclass: #MADescriptionEditor
	instanceVariableNames: 'description report example'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MADescriptionEditor class methodsFor: 'instance creation' stamp: 'lr 3/21/2005 18:02'!
description: aDescription
	^self new
		setDescription: aDescription;
		yourself.! !

!MADescriptionEditor class methodsFor: 'examples' stamp: 'lr 3/21/2005 17:53'!
example
	^self description: MAComposedDescription new.! !

!MADescriptionEditor methodsFor: 'actions' stamp: 'lr 3/21/2005 19:40'!
addDescription: aDescription
	| element |
	element := self call: (self 
		buildEditorFor: aDescription 
		titled: 'Add ' , aDescription description label).
	element isNil ifFalse: [
		self description add: element.
		self report refresh ].! !

!MADescriptionEditor methodsFor: 'private' stamp: 'lr 3/21/2005 19:04'!
buildEditorFor: aDescription titled: aString
	^aDescription asComponent
		addValidatedForm;
		addMessage: aString;
		yourself.! !

!MADescriptionEditor methodsFor: 'accessing' stamp: 'lr 3/21/2005 18:03'!
children
	^Array with: self report.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 3/21/2005 18:55'!
defaultDescriptionClasses
	^OrderedCollection new
		add: MAStringDescription;
		add: MATextDescription;
		add: MASymbolDescription;
		add: MAPasswordDescription;
		add: nil;
		add: MABooleanDescription;
		add: MAOptionsDescription;
		add: nil;
		add: MANumberDescription;
		add: MADurationDescription;
		add: MADateDescription;
		add: MATimeDescription;
		add: MATimeStampDescription;
		add: nil;
		add: MATableDescription;
		add: MABinaryDescription;
		yourself.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 3/21/2005 19:53'!
defaultExampleInstance
	^MADescribedScaffolder description: self description.! !

!MADescriptionEditor methodsFor: 'accessing-configuration' stamp: 'lr 3/21/2005 19:39'!
defaultReportInstance
	^(MAReport rows: self description description: MAElementDescription description)
		addColumn: (MAColumn new
			cascade: #( description label );
			title: 'Kind';
			yourself);
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #editDescription: text: 'edit';
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #removeDescription: text: 'remove';
			yourself);
		yourself.! !

!MADescriptionEditor methodsFor: 'accessing' stamp: 'lr 3/21/2005 17:53'!
description
	^description! !

!MADescriptionEditor methodsFor: 'actions' stamp: 'lr 3/21/2005 19:41'!
editDescription: aDescription
	self call: (self 
		buildEditorFor: aDescription 
		titled: 'Edit ' , aDescription description label).
	self report refresh.! !

!MADescriptionEditor methodsFor: 'accessing' stamp: 'lr 3/21/2005 19:38'!
example
	example isNil
		ifTrue: [ example := self defaultExampleInstance ].
	^example.! !

!MADescriptionEditor methodsFor: 'actions' stamp: 'lr 3/21/2005 19:41'!
moveDown: aDescription
	self description moveDown: aDescription.
	self report refresh.! !

!MADescriptionEditor methodsFor: 'actions' stamp: 'lr 3/21/2005 19:41'!
moveUp: aDescription
	self description moveUp: aDescription.
	self report refresh.! !

!MADescriptionEditor methodsFor: 'actions' stamp: 'lr 3/21/2005 19:41'!
preview
	self call: (self example asComponent
		addValidatedForm;
		yourself).! !

!MADescriptionEditor methodsFor: 'actions' stamp: 'lr 3/21/2005 19:41'!
removeDescription: aDescription
	self description remove: aDescription.
	self report refresh.! !

!MADescriptionEditor methodsFor: 'rendering' stamp: 'lr 3/23/2005 00:04'!
renderAddOn: html
	| selected |
	selected := ValueHolder new.
	html
		selectFromList: self defaultDescriptionClasses 
		selected: self defaultDescriptionClasses first
		callback: [ :class | selected contents: class ]
		labels: [ :class | 
			class isNil
				ifTrue: [ '--' ]
				ifFalse: [ class description label ] ].
	html
		submitButtonWithAction: [
			selected contents ifNotNilDo: [ :class | 
				self addDescription: class new ] ]
		text: 'add'.! !

!MADescriptionEditor methodsFor: 'accessing' stamp: 'lr 3/21/2005 19:39'!
report
	report isNil
		ifTrue: [ report := self defaultReportInstance ].
	^report.! !

!MADescriptionEditor methodsFor: 'actions' stamp: 'lr 3/22/2005 23:44'!
save
	 self answer: self description.! !

!MADescriptionEditor methodsFor: 'initialization' stamp: 'lr 3/21/2005 19:03'!
setDescription: aDescription
	description := aDescription copy.! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 3/22/2005 23:44'!
cancel
	self answer: nil.! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 3/22/2005 23:46'!
preview
	self subclassResponsibility.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/22/2005 23:43'!
renderActionsOn: html
	html
		submitButtonWithAction: [ self save ]
		text: 'save'.
	html
		submitButtonWithAction: [ self cancel ]
		text: 'cancel'.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/22/2005 23:49'!
renderAddOn: html
	self subclassResponsibility.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/22/2005 23:42'!
renderButtonsOn: html
	html form: [
		self renderAddOn: html.
		self renderPreviewOn: html.
		self renderActionsOn: html ].! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/22/2005 23:48'!
renderChildrenOn: html
	html render: self children.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/22/2005 23:48'!
renderContentOn: html
	self renderChildrenOn: html.
	self renderButtonsOn: html.! !

!MAExampleEditor methodsFor: 'rendering' stamp: 'lr 3/22/2005 23:41'!
renderPreviewOn: html
	html
		submitButtonWithAction: [ self preview ]
		text: 'preview'.! !

!MAExampleEditor methodsFor: 'actions' stamp: 'lr 3/22/2005 23:44'!
save
	self subclassResponsibility.! !

MAExampleEditor subclass: #MAReportEditor
	instanceVariableNames: 'report columns visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MAReportEditor class methodsFor: 'examples' stamp: 'lr 3/23/2005 00:12'!
example
	^self report: MAReport example.! !

!MAReportEditor class methodsFor: 'instance creation' stamp: 'lr 3/23/2005 00:02'!
report: aReport
	^self new
		setReport: aReport;
		yourself.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/23/2005 00:01'!
addColumn: aColumn
	self report addColumn: aColumn.
	self refresh.! !

!MAReportEditor methodsFor: 'private' stamp: 'lr 3/23/2005 00:30'!
buildColumns
	^(MAReport rows: self report columns)
		addColumn: self visible;
		addColumnDescription: MAColumn descriptionTitle;
		addColumnDescription: MAColumn descriptionComment;
		addColumn: (MACommandColumn new
			addCommandOn: self selector: #moveUp: text: 'up';
			addCommandOn: self selector: #moveDown: text: 'down';
			addCommandOn: self selector: #remove: text: 'remove';
			yourself);
		yourself.
			! !

!MAReportEditor methodsFor: 'private' stamp: 'lr 3/23/2005 00:39'!
buildVisible
	^MACheckboxColumn new
		title: 'V';
		comment: 'Visibility';
		selection: (self report columns 
			select: [ :each | each isVisible ])
			asSet;
		yourself.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 3/23/2005 00:06'!
children
	^Array with: self columns.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 3/22/2005 23:21'!
columns
	columns isNil
		ifTrue: [ columns := self buildColumns ].
	^columns.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/23/2005 00:01'!
moveDown: aColumn
	self report moveDown: aColumn.
	self refresh.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/23/2005 00:01'!
moveUp: aColumn
	self report moveUp: aColumn.
	self refresh.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/23/2005 00:09'!
preview	
	self report
		decorateWith: (WAWindowDecoration new
			title: self report tableCaption;
			yourself)
		during: [ self call: self report ].! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/23/2005 00:00'!
refresh
	self columns rows: self report columns.! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/23/2005 00:01'!
remove: aColumn
	self report remove: aColumn.
	self refresh.! !

!MAReportEditor methodsFor: 'rendering' stamp: 'lr 3/23/2005 00:07'!
renderAddOn: html
	| selected |
	selected := ValueHolder new.
	"html
		selectFromList: self columns selected: nil
		callback: [ :value | selected contents: value ]
		labels: [ :value | value title ]."
	html
		submitButtonWithAction: [
			selected contents ifNotNilDo: [ :value | 
				self addColumn: value copy ] ]
		text: 'add'.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 3/22/2005 23:21'!
report
	^report! !

!MAReportEditor methodsFor: 'actions' stamp: 'lr 3/22/2005 23:45'!
save
	 self answer: self report.! !

!MAReportEditor methodsFor: 'initialization' stamp: 'lr 3/23/2005 00:02'!
setReport: aReport
	report := aReport copy.! !

!MAReportEditor methodsFor: 'accessing' stamp: 'lr 3/23/2005 00:32'!
visible
	visible isNil
		ifTrue: [ visible := self buildVisible ].
	^visible.! !

WAComponent subclass: #MAReport
	instanceVariableNames: 'rows cache columns properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/22/2005 22:50'!
description2000
	^MABooleanDescription key: #showHeader label: 'Show Header' priority: 2000.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/22/2005 22:50'!
description2100
	^MABooleanDescription key: #showBody label: 'Show Body' priority: 2100.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/22/2005 22:52'!
description2200
	^MAStringDescription key: #tableEmpty label: 'Empty' priority: 2200.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/22/2005 22:52'!
description2300
	^MABooleanDescription key: #showFooter label: 'Show Footer' priority: 2300.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/22/2005 22:52'!
description2400
	^MABooleanDescription key: #showCaption label: 'Show Caption' priority: 2300.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/22/2005 22:53'!
description2500
	^MAStringDescription key: #tableCaption label: 'Caption' priority: 2500.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/22/2005 22:53'!
description2600
	^MABooleanDescription key: #showSummary label: 'Show Summary' priority: 2600.! !

!MAReport class methodsFor: 'accessing-description-table' stamp: 'lr 3/22/2005 22:54'!
description2700
	^MAStringDescription key: #tableSummary label: 'Summary' priority: 2700.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 3/22/2005 22:48'!
description4000
	^MABooleanDescription key: #showBatch label: 'Show Batch' priority: 4000.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 3/22/2005 22:49'!
description4100
	^MANumberDescription key: #batchSize label: 'Size' priority: 4100.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 3/22/2005 22:49'!
description4200
	^MABooleanDescription key: #showBatchFirstLast label: 'Show First/Last' priority: 4200.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 3/22/2005 22:49'!
description4300
	^MABooleanDescription key: #showBatchPreviousNext label: 'Show Previous/Next' priority: 4300.! !

!MAReport class methodsFor: 'accessing-description-batch' stamp: 'lr 3/22/2005 22:49'!
description4400
	^MABooleanDescription key: #showBatchPages label: 'Show Pages' priority: 4400.! !

!MAReport class methodsFor: 'examples' stamp: 'lr 3/23/2005 00:24'!
example
	^(MAReport rows: (0 to: 255))
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the decimal number';
			title: 'Dec');
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the binary number';
			title: 'Bin';
			format: [ :value | (value printStringBase: 2) allButFirst: 2 ];
			yourself);
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the octal number';
			title: 'Oct';
			format: [ :value | (value printStringBase: 8) allButFirst: 2 ];
			yourself);
		addColumn: (MAColumn new
			selector: #yourself;
			comment: 'the hexadecimal number';
			title: 'Hex';
			format: [ :value | (value printStringBase: 16) allButFirst: 3 ];
			yourself);
		addColumn: (MAColumn new
			selector: #sin;
			comment: 'the sinus';
			title: 'Sinus');
		addColumn: (MAColumn new
			selector: #cos;
			comment: 'the cosinus';
			title: 'Cosinus');
		addColumn: (MAColumn new
			selector: #ln;
			comment: 'the natural logarithm';
			title: 'Logarithm');
		addColumn: (MAColumn new
			selector: #exp;
			comment: 'the exponential';
			title: 'Exponential');
		yourself.! !

!MAReport class methodsFor: 'instance creation' stamp: 'lr 3/21/2005 16:45'!
rows: aCollection
	^self new
		rows: aCollection;
		yourself.! !

!MAReport class methodsFor: 'instance creation' stamp: 'lr 3/21/2005 18:03'!
rows: aCollection description: aDescription
	| report |
	report := self rows: aCollection.
	aDescription asComposed do: [ :each |
		report addColumnDescription: each ].
	^report.! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/21/2005 16:56'!
addColumn: aColumn
	columns := columns copyWith: aColumn.
	^aColumn setReport: self; yourself.! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/21/2005 19:08'!
addColumnCascade: anArray
	^(self addColumn: MAColumn new)
		cascade: anArray;
		yourself.! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/21/2005 17:40'!
addColumnDescription: aDescription
	^self addColumn: (MADescribedColumn new
		setDescription: aDescription;
		yourself).! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/21/2005 19:09'!
addColumnSelector: aSelector
	^(self addColumn: MAColumn new)
		selector: aSelector;
		yourself.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:25'!
backtrackedAt: aSymbol
	^(self propertyAt: aSymbol)
		contents.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:27'!
backtrackedAt: aSymbol ifAbsent: aBlock
	^(self propertyAt: aSymbol ifAbsent: [ ^aBlock value ])
		contents.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:29'!
backtrackedAt: aSymbol ifAbsentPut: aBlock
	^self 
		backtrackedAt: aSymbol 
		ifAbsent: [ self backtrackedAt: aSymbol put: aBlock value ].! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:26'!
backtrackedAt: aSymbol put: anObject
	(self propertyAt: aSymbol ifAbsentPut: [ WAStateHolder new ])
		contents: anObject.
	^anObject.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:35'!
batchEndIndex
	^self batchPage * self batchSize min: self cache size.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:35'!
batchMaxPages
	^(self cache size / self batchSize) 
		ceiling.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:42'!
batchPage
	^self backtrackedAt: #batchPage ifAbsentPut: [ self defaultBatchPage ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:37'!
batchPage: anInteger
	self backtrackedAt: #batchPage put: anInteger.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:35'!
batchPageRange
	^self batchPageRangeStart to: self batchPageRangeEnd.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:35'!
batchPageRangeEnd
	^self batchMaxPages min: self batchPage + 9.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:35'!
batchPageRangeStart
	^self defaultBatchPage max: self batchPage - 9.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:42'!
batchSize
	^self propertyAt: #batchSize ifAbsentPut: [ self defaultBatchSize ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:37'!
batchSize: anInteger
	self propertyAt: #batchSize put: anInteger.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:36'!
batchStartIndex
	^(self batchPage - 1) * self batchSize + 1.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:21'!
cache
	"Return the cached rows of the receiver, these rows are filtered and sorted."

	cache isNil ifTrue: [ 
		self cache: (self 
			sortRows: (self 
				filterRows: self 
					rows)) ].
	^cache.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:21'!
cache: aCollection
	cache := aCollection! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 3/21/2005 16:34'!
columns
	^columns! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:40'!
defaultBatchPage
	^1! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:40'!
defaultBatchSize
	^10! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:40'!
defaultRowFilter
	^nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:40'!
defaultRowPeriod
	^1! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultRowStyles
	^Array with: 'odd' with: 'even'.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowBatch
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 19:51'!
defaultShowBatchFirstLast
	^false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowBatchPages
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowBatchPreviousNext
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowBody
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowCaption
	^false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowFooter
	^false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowHeader
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultShowSummary
	^false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultSortArrowDown
	^ScriptingSystem formAtKey: #DownArrow.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultSortArrowUp
	^ScriptingSystem formAtKey: #UpArrow.! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultSortColumn
	^nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultSortEnabled
	^true! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:41'!
defaultSortReversed
	^false! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:42'!
defaultTableCaption
	^nil! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:42'!
defaultTableEmpty
	^'The report is empty.'! !

!MAReport methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:42'!
defaultTableSummary
	^nil! !

!MAReport methodsFor: 'private' stamp: 'lr 3/21/2005 16:30'!
filterRows: aCollection
	^self hasRowFilter
		ifFalse: [ aCollection ]
		ifTrue: [ aCollection select: self rowFilter ].! !

!MAReport methodsFor: 'testing' stamp: 'lr 3/21/2005 16:30'!
hasRowFilter
	^self rowFilter notNil.! !

!MAReport methodsFor: 'initialization' stamp: 'lr 3/21/2005 16:56'!
initialize
	super initialize.
	rows := columns := Array new.
	properties := Dictionary new.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:36'!
isOnFirstPage
	^self batchPage = 1.! !

!MAReport methodsFor: 'private-batch' stamp: 'lr 3/21/2005 16:36'!
isOnLastPage
	^self batchPage = self batchMaxPages.! !

!MAReport methodsFor: 'testing' stamp: 'lr 3/21/2005 16:30'!
isSorted
	^self sortColumn notNil.! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/22/2005 23:56'!
moveDown: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^self ].
	self columns swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ]).! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/22/2005 23:57'!
moveUp: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^self ].
	self columns swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ]).! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/21/2005 16:34'!
nextPage
	self isOnLastPage 
		ifFalse: [ self batchPage: self batchPage + 1 ].! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/21/2005 16:34'!
previousPage
	self isOnFirstPage 
		ifFalse: [ self batchPage: self batchPage - 1 ].! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:23'!
properties
	^properties! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:23'!
propertyAt: aSymbol
	^self properties at: aSymbol! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:23'!
propertyAt: aSymbol ifAbsent: aBlock
	^self properties at: aSymbol ifAbsent: aBlock.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:23'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^self properties at: aSymbol ifAbsentPut: aBlock.! !

!MAReport methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:22'!
propertyAt: aSymbol put: anObject
	^self properties at: aSymbol put: anObject.! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/21/2005 16:34'!
refresh
	self cache: nil; batchPage: self defaultBatchPage.
	self columns do: [ :each | each refresh ].! !

!MAReport methodsFor: 'columns' stamp: 'lr 3/22/2005 23:58'!
remove: aColumn
	columns := columns copyWithout: aColumn.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 3/21/2005 16:32'!
renderBatchFirstOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self batchPage: self defaultBatchPage ] text: '|<' ]
		ifTrue: [ html text: '|<' ].
	html space.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 3/21/2005 16:32'!
renderBatchItemsOn: html
	self batchPageRangeStart > self defaultBatchPage
		ifTrue: [ html text: '...'; space ].
	self batchPageRange do: [ :index |
		self batchPage = index
			ifFalse: [ html anchorWithAction: [ self batchPage: index ] text: index ]
			ifTrue: [ html spanClass: 'current' with: index ].
		html space ].
	self batchPageRangeEnd < self batchMaxPages 
		ifTrue: [ html text: '...'; space ].! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 3/21/2005 16:32'!
renderBatchLastOn: html
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self batchPage: self batchMaxPages ] text: '>|' ]
		ifTrue: [ html text: '>|' ].! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 3/21/2005 16:32'!
renderBatchNextOn: html
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self nextPage ] text: '>>' ]
		ifTrue: [ html text: '>>' ].
	html space.! !

!MAReport methodsFor: 'rendering-batch' stamp: 'lr 3/21/2005 16:32'!
renderBatchPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self previousPage ] text: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!MAReport methodsFor: 'rendering' stamp: 'lr 3/21/2005 16:33'!
renderContentOn: html
	html cssClass: 'report'; table: [ self renderTableOn: html ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableBatchOn: html
	self batchSize < self cache size ifTrue: [
		html tableRow: [
			html cssClass: 'batch'; attributeAt: 'colspan' put: self columns size.
			html tableData: [
				self showBatchFirstLast
					ifTrue: [ self renderBatchFirstOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchPreviousOn: html ].
				self showBatchPages
					ifTrue: [ self renderBatchItemsOn: html ].
				self showBatchPreviousNext
					ifTrue: [ self renderBatchNextOn: html ].
				self showBatchFirstLast
					ifTrue: [ self renderBatchLastOn: html ] ] ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableBodyOn: html
	self visible isEmpty 
		ifTrue: [
			html cssClass: 'empty'.
			html tableRow: [
				html attributeAt: #colspan put: self columns size.
				html tableData: [
					html render: self tableEmpty ] ] ]
		ifFalse: [
			self visible withIndexDo: [ :row :index |
				html cssClass: (self rowStyleForNumber: index).
				html tableRow: [
					self columns do: [ :col |
						col 
							renderCell: (col valueFor: row) 
							index: index on: html ] ] ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableCaptionOn: html
	html tag: 'caption' do: self tableCaption.! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableFootOn: html
	html tableRow: [
		self columns do: [ :each |
			each renderFootCellOn: html ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableHeadOn: html
	html tableRow: [
		self columns do: [ :each |
			each renderHeadCellOn: html ] ].! !

!MAReport methodsFor: 'rendering' stamp: 'lr 3/21/2005 16:33'!
renderTableOn: html
	self showCaption
		ifTrue: [ self renderTableCaptionOn: html ].
	self showSummary
		ifTrue: [ self renderTableSummaryOn: html ].
	html tag: 'thead' do: [
		self showHeader
			ifTrue: [ self renderTableHeadOn: html ] ].
	html tag: 'tbody' do: [
		self showBody 
			ifTrue: [ self renderTableBodyOn: html ] ].
	html tag: 'tfoot' do: [
		self showFooter
			ifTrue: [ self renderTableFootOn: html ].
		self showBatch
			ifTrue: [ self renderTableBatchOn: html ] ].! !

!MAReport methodsFor: 'rendering-table' stamp: 'lr 3/21/2005 16:31'!
renderTableSummaryOn: html
	html tag: 'summary' do: self tableSummary.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:42'!
rowFilter
	^self backtrackedAt: #rowFilter ifAbsentPut: [ self defaultRowFilter ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:37'!
rowFilter: aBlock
	self backtrackedAt: #rowFilter put: aBlock.
	self refresh.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
rowPeriod
	^self propertyAt: #rowPeriod ifAbsentPut: [ self defaultRowPeriod ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:37'!
rowPeriod: aNumber
	self propertyAt: #rowPeriod put: aNumber.! !

!MAReport methodsFor: 'private' stamp: 'lr 3/21/2005 16:30'!
rowStyleForNumber: aNumber
	^self rowStyles 
		at: ((aNumber - 1 // self rowPeriod) \\ self rowStyles size) + 1
		ifAbsent: [ String new ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
rowStyles
	^self propertyAt: #rowStyles ifAbsentPut: [ self defaultRowStyles ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:37'!
rowStyles: aCollection
	self propertyAt: #rowStyles put: aCollection.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:21'!
rows
	"Return the rows of the receiver."

	rows isNil
		ifTrue: [ self rows: Array new ].
	^rows.! !

!MAReport methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:22'!
rows: aCollection
	"Set the rows of the receiver."
	
	rows := aCollection.
	self refresh.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showBatch
	^self propertyAt: #showBatch ifAbsentPut: [ self defaultShowBatch ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showBatch: aBoolean
	self propertyAt: #showBatch put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showBatchFirstLast
	^self propertyAt: #showBatchFirstLast ifAbsentPut: [ self defaultShowBatchFirstLast ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showBatchFirstLast: aBoolean
	self propertyAt: #showBatchFirstLast put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showBatchPages
	^self propertyAt: #showBatchPages ifAbsentPut: [ self defaultShowBatchPages ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showBatchPages: aBoolean
	self propertyAt: #showBatchPages put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showBatchPreviousNext
	^self propertyAt: #showBatchPreviousNext ifAbsentPut: [ self defaultShowBatchPreviousNext ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showBatchPreviousNext: aBoolean
	self propertyAt: #showBatchPreviousNext put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showBody
	^self propertyAt: #showBody ifAbsentPut: [ self defaultShowBody ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showBody: aBoolean
	self propertyAt: #showBody put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showCaption
	^self propertyAt: #showCaption ifAbsentPut: [ self defaultShowCaption ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showCaption: aBoolean
	self propertyAt: #showCaption put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showFooter
	^self propertyAt: #showFooter ifAbsentPut: [ self defaultShowFooter ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:38'!
showFooter: aBoolean
	self propertyAt: #showFooter put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showHeader
	^self propertyAt: #showHeader ifAbsentPut: [ self defaultShowHeader ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
showHeader: aBoolean
	self propertyAt: #showHeader put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:43'!
showSummary
	^self propertyAt: #showSummary ifAbsentPut: [ self defaultShowSummary ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
showSummary: aBoolean
	self propertyAt: #showSummary put: aBoolean.! !

!MAReport methodsFor: 'actions' stamp: 'lr 3/21/2005 16:34'!
sort: aColumn
	aColumn = self sortColumn
		ifTrue: [
			self sortReversed
				ifFalse: [ self sortReversed: true ]
				ifTrue: [ self sortColumn: nil; sortReversed: false ] ]
		ifFalse: [ self sortColumn: aColumn; sortReversed: false ].
	self refresh.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
sortArrowDown
	^self propertyAt: #sortArrowDown ifAbsentPut: [ self defaultSortArrowDown ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
sortArrowDown: aForm
	self propertyAt: #sortArrowDown put: aForm.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
sortArrowUp
	^self propertyAt: #sortArrowUp ifAbsentPut: [ self defaultSortArrowUp ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
sortArrowUp: aForm
	self propertyAt: #sortArrowUp put: aForm.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
sortColumn
	^self backtrackedAt: #sortColumn ifAbsentPut: [ self defaultSortColumn ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
sortColumn: aColumn
	self backtrackedAt: #sortColumn put: aColumn.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
sortEnabled
	^self propertyAt: #sortEnabled ifAbsentPut: [ self defaultSortEnabled ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:39'!
sortEnabled: aBoolean
	self propertyAt: #sortEnabled put: aBoolean.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
sortReversed
	^self backtrackedAt: #sortReversed ifAbsentPut: [ self defaultSortReversed ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:40'!
sortReversed: aBoolean
	self backtrackedAt: #sortReversed put: aBoolean.! !

!MAReport methodsFor: 'private' stamp: 'lr 3/21/2005 16:30'!
sortRows: aCollection
	^self isSorted
		ifFalse: [ aCollection ]
		ifTrue: [ self sortColumn sortRows: aCollection ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
tableCaption
	^self propertyAt: #tableCaption ifAbsentPut: [ self defaultTableCaption ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:40'!
tableCaption: aString
	self propertyAt: #tableCaption put: aString.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
tableEmpty
	^self propertyAt: #tableEmpty ifAbsentPut: [ self defaultTableEmpty ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:40'!
tableEmpty: aString
	self propertyAt: #tableEmpty put: aString.! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:44'!
tableSummary
	^self propertyAt: #tableSummary ifAbsentPut: [ self defaultTableSummary ].! !

!MAReport methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:40'!
tableSummary: aString
	self propertyAt: #tableSummary put: aString.! !

!MAReport methodsFor: 'accessing-readonly' stamp: 'lr 3/21/2005 16:34'!
visible
	^self showBatch
		ifFalse: [ self cache ]
		ifTrue: [
			self cache
				copyFrom: self batchStartIndex
				to: self batchEndIndex ].! !

!MANumberDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MATextInputComponent! !

Object subclass: #MAColumn
	instanceVariableNames: 'report properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

MAColumn subclass: #MAActionColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 19:12'!
defaultTitle
	^String new.! !

!MAActionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:46'!
defaultUseLinks
	^true! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 15:47'!
renderCellContent: anObject index: aNumber on: html
	self useLinks 
		ifTrue: [ self renderCellLinkContent: anObject index: aNumber on: html ]
		ifFalse: [ self renderCellFormContent: anObject index: aNumber on: html ].! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 15:47'!
renderCellFormContent: anObject index: aNumber on: html
	self subclassResponsibility.! !

!MAActionColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 15:47'!
renderCellLinkContent: anObject index: aNumber on: html
	self subclassResponsibility.! !

!MAActionColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:12'!
useLinks
	^self propertyAt: #useLinks ifAbsent: [ self defaultUseLinks ].! !

!MAActionColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 15:46'!
useLinks: aBoolean
	self propertyAt: #useLinks put: aBoolean.! !

MAActionColumn subclass: #MACommandColumn
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MACommandColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 16:19'!
addCommand: aBlock text: aString
	self commands add: aBlock -> aString.! !

!MACommandColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 19:11'!
addCommandOn: anObject selector: aSelector text: aString
	self addCommand: (MessageSend receiver: anObject selector: aSelector) text: aString.! !

!MACommandColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:19'!
commands
	^commands! !

!MACommandColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 16:19'!
commands: aCollection
	commands := aCollection! !

!MACommandColumn methodsFor: 'initialization' stamp: 'lr 3/21/2005 16:18'!
initialize
	super initialize.
	self commands: OrderedCollection new.! !

!MACommandColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 16:17'!
renderCellFormContent: anObject index: aNumber on: html
	self commands
		do: [ :each |
			html
				submitButtonWithAction: [ each key value: anObject ] 
				text: each value ]
		separatedBy: [ html space ].! !

!MACommandColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 16:17'!
renderCellLinkContent: anObject index: aNumber on: html
	self commands
		do: [ :each | 
			html 
				anchorWithAction: [ each key value: anObject ] 
				text: each value ]
		separatedBy: [ html space ].! !

MAActionColumn subclass: #MASelectionColumn
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

MASelectionColumn subclass: #MACheckboxColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:58'!
defaultFormDeselected
	^ScriptingSystem formAtKey: #CheckBoxOff.! !

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:58'!
defaultFormSelected
	^ScriptingSystem formAtKey: #CheckBoxOn.! !

!MACheckboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:58'!
defaultSelection
	^Set new.! !

!MACheckboxColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:55'!
deselect: anObject
	self selection remove: anObject ifAbsent: nil.! !

!MACheckboxColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 15:53'!
isSelected: anObject
	^self selection includes: anObject.! !

!MACheckboxColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 20:52'!
renderCellFormContent: anObject index: aNumber on: html
	html 
		checkboxWithValue: (self isSelected: anObject) 
		callback: [ :value | self select: anObject value: value ].! !

!MACheckboxColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:55'!
select: anObject
	self selection add: anObject.! !

MASelectionColumn subclass: #MAOptionboxColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:01'!
defaultFormDeselected
	^ScriptingSystem formDictionary  formAtKey: #RadioButtonOff.! !

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:01'!
defaultFormSelected
	^ScriptingSystem formAtKey: #RadioButtonOn.! !

!MAOptionboxColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:56'!
defaultSelection
	^nil! !

!MAOptionboxColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:54'!
deselect: anObject
	self selection: nil.! !

!MAOptionboxColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 15:54'!
isSelected: anObject
	^self selection == anObject.! !

!MAOptionboxColumn methodsFor: 'private' stamp: 'lr 3/21/2005 16:15'!
radioGroupFor: html
	"This is a very bad thing, you might never have seen in your own life. Very strange things might happen here, but for now it mostly does what we need."
	
	| renderer |
	renderer := self propertyAt: #radioGroupRenderer ifAbsentPut: nil.
	^renderer == html 
		ifTrue: [ self propertyAt: #radioGroupCallback ]
		ifFalse: [
			self propertyAt: #radioGroupRenderer put: html.
			self propertyAt: #radioGroupCallback put: html radioGroup ].! !

!MAOptionboxColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 16:04'!
renderCellFormContent: anObject index: aNumber on: html
	html
		radioButtonInGroup: (self radioGroupFor: html) 
		selected: (self isSelected: anObject) 
		callback: [ self select: anObject ].! !

!MAOptionboxColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:54'!
select: anObject
	self selection: anObject.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:01'!
defaultFormDeselected
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 16:01'!
defaultFormSelected
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:55'!
defaultSelection
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:52'!
deselect: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:12'!
formDeselected
	^self propertyAt: #formDeselected ifAbsent: [ self defaultFormDeselected ].! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:02'!
formDeselected: aForm
	^self propertyAt: #formDeselected put: aForm.! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:13'!
formSelected
	^self propertyAt: #formSelected ifAbsent: [ self defaultFormSelected ].! !

!MASelectionColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 16:01'!
formSelected: aForm
	^self propertyAt: #formSelected put: aForm.! !

!MASelectionColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 15:53'!
isSelected: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:55'!
refresh
	super refresh.
	self selection: self defaultSelection.! !

!MASelectionColumn methodsFor: 'rendering' stamp: 'lr 3/23/2005 00:35'!
renderCellLinkContent: anObject index: aNumber on: html
	| selected |
	selected := self isSelected: anObject.
	html
		anchorWithAction: [ self select: anObject value: selected not ]
		do: [ 
			html imageWithForm: (selected
				ifTrue: [ self formSelected ]
				ifFalse: [ self formDeselected ]) ].! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:52'!
select: anObject
	self subclassResponsibility.! !

!MASelectionColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 20:51'!
select: anObject value: aBoolean
	aBoolean
		ifTrue: [ self select: anObject ]
		ifFalse: [ self deselect: anObject ].! !

!MASelectionColumn methodsFor: 'accessing' stamp: 'lr 3/23/2005 00:34'!
selection
	selection isNil
		ifTrue: [ self selection: self defaultSelection ].
	^selection! !

!MASelectionColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 15:48'!
selection: anObject
	selection := anObject! !

!MAColumn class methodsFor: 'accessing-description' stamp: 'lr 3/22/2005 23:34'!
descriptionComment
	^MAStringDescription key: #comment label: 'Comment' priority: 200.! !

!MAColumn class methodsFor: 'accessing-description' stamp: 'lr 3/22/2005 23:34'!
descriptionTitle
	^MAStringDescription key: #title label: 'Title' priority: 100.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 18:04'!
cascade
	^self propertyAt: #cascade ifAbsent: [ self defaultCascade ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 17:36'!
cascade: anArray
	self propertyAt: #cascade put: anArray.! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 17:30'!
column
	^self report cache
		collect: [ :each | self valueFor: each ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/22/2005 23:33'!
comment
	^self propertyAt: #comment ifAbsent: [ self defaultComment ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/22/2005 23:33'!
comment: aString
	self propertyAt: #comment put: aString.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:31'!
defaultCascade
	^ #( yourself )! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 00:39'!
defaultComment
	^nil! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:31'!
defaultDownArrow
	^ScriptingSystem formAtKey: #DownArrow.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:45'!
defaultFooter
	^nil! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:31'!
defaultFormat
	^MessageSend receiver: self selector: #renderCellContent:index:on:.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 15:45'!
defaultSorter
	^[ :a :b | a < b ]! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:31'!
defaultTitle
	^self cascade first asCapitalizedPhrase.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:31'!
defaultUpArrow
	^ScriptingSystem formAtKey: #UpArrow.! !

!MAColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/23/2005 00:36'!
defaultVisible
	^true! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 18:04'!
footer
	^self propertyAt: #footer ifAbsent: [ self defaultFooter ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 17:29'!
footer: aBlock
	self propertyAt: #footer put: aBlock.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 18:04'!
format
	^self propertyAt: #format ifAbsent: [ self defaultFormat ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 17:29'!
format: aBlock
	self propertyAt: #format put: aBlock.! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 17:30'!
index
	^self report columns indexOf: self.! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 3/21/2005 15:39'!
initialize
	super initialize.
	properties := Dictionary new.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 17:33'!
isReversed
	^self report sortReversed.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 17:33'!
isSortable
	^self report sortEnabled 
		and: [ self sorter notNil ].! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/21/2005 17:33'!
isSorted
	^self report sortColumn = self.! !

!MAColumn methodsFor: 'testing' stamp: 'lr 3/23/2005 00:38'!
isVisible
	^self visible.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 15:41'!
properties
	^properties! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:13'!
propertyAt: aSymbol
	^self properties at: aSymbol.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:13'!
propertyAt: aSymbol ifAbsent: aBlock
	^self properties at: aSymbol ifAbsent: aBlock.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 16:12'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^self properties at: aSymbol ifAbsentPut: aBlock.! !

!MAColumn methodsFor: 'accessing-properties' stamp: 'lr 3/21/2005 15:41'!
propertyAt: aSymbol put: anObject
	^self properties at: aSymbol put: anObject.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 15:42'!
refresh! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/23/2005 00:47'!
renderCell: anObject index: aNumber on: html
	html tableData: [
		self format in: [ :format |
			format numArgs caseOf: {
				[ 1 ] -> [ html render: (format value: anObject) ].
				[ 2 ] -> [ format valueWithArguments: (Array with: anObject with: html) ].
				[ 3 ] -> [ format valueWithArguments: (Array with: anObject with: aNumber with: html) ].
			} otherwise: [ self error: 'Invalid renderer block' ] ] ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:32'!
renderCellContent: anObject index: aNumber on: html
	html render: anObject.! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:33'!
renderFootCellOn: html
	html tableData: [ self renderFootContentOn: html ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:33'!
renderFootContentOn: html
	self footer isNil
		ifFalse: [ html render: self footer ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/23/2005 00:47'!
renderHeadCellOn: html
	self comment isEmptyOrNil
		ifFalse: [ html attributeAt: 'title' put: self comment ].
	html tableData: [ 
		self isSortable
			ifFalse: [ self renderHeadContentOn: html ]
			ifTrue: [
				html
					anchorWithCallback: [ self report sort: self ]
					do: [ 
						self renderHeadContentOn: html.
						self renderHeadSorterOn: html ] ] ].! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:33'!
renderHeadContentOn: html
	html render: self title.! !

!MAColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:33'!
renderHeadSorterOn: html
	self isSorted ifTrue: [
		html imageWithForm: (self isReversed 
			ifTrue: [ self report sortArrowUp ]
			ifFalse: [ self report sortArrowDown ]) ].! !

!MAColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 17:30'!
report
	^report! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 17:34'!
selector: aSymbol
	self cascade: (Array with: aSymbol).! !

!MAColumn methodsFor: 'initialization' stamp: 'lr 3/21/2005 15:40'!
setReport: aReport
	report := aReport.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 19:50'!
sortRows: aCollection
	| result |
	result := SortedCollection new: aCollection size.
	result 
		sortBlock: [ :a :b | 
			[ (self valueFor: a) < (self valueFor: b) ]
				ifError: [ false ] ];
		addAll: aCollection.
	^self isReversed
		ifFalse: [ result ]
		ifTrue: [ result reversed ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 18:04'!
sorter
	^self propertyAt: #sorter ifAbsent: [ self defaultSorter ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 17:29'!
sorter: aBlock
	self propertyAt: #sorter put: aBlock.! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 18:04'!
title
	^self propertyAt: #title ifAbsent: [ self defaultTitle ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/21/2005 17:29'!
title: aString
	self propertyAt: #title put: aString.! !

!MAColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 17:32'!
valueFor: aRow
	^self cascade
		inject: aRow
		into: [ :result :each | result perform: each ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 00:37'!
visible
	^self propertyAt: #visible ifAbsent: [ self defaultVisible ].! !

!MAColumn methodsFor: 'accessing-settings' stamp: 'lr 3/23/2005 00:36'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean.! !

MAColumn subclass: #MADescribedColumn
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Report'!

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:39'!
defaultCascade
	self shouldNotImplement.! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 18:05'!
defaultSorter
	^(self description comparators includes: MAComparator lessThan)
		ifTrue: [ super defaultSorter ].! !

!MADescribedColumn methodsFor: 'accessing-defaults' stamp: 'lr 3/21/2005 17:37'!
defaultTitle
	^self description label.! !

!MADescribedColumn methodsFor: 'accessing' stamp: 'lr 3/21/2005 17:34'!
description
	^description! !

!MADescribedColumn methodsFor: 'rendering' stamp: 'lr 3/21/2005 17:48'!
renderCellContent: anObject index: aNumber on: html
	html render: (self description toString: anObject).! !

!MADescribedColumn methodsFor: 'initialization' stamp: 'lr 3/21/2005 17:35'!
setDescription: aDescription
	description := aDescription! !

!MADescribedColumn methodsFor: 'actions' stamp: 'lr 3/21/2005 17:46'!
valueFor: aRow
	^self description read: aRow.! !

Object subclass: #MARenderer
	instanceVariableNames: 'html component readonly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

MARenderer subclass: #MACssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MACssRenderer methodsFor: 'private' stamp: 'lr 3/14/2005 14:20'!
cssClass: aString modificators: aDescription
	^String streamContents: [ :stream |
		stream nextPutAll: aString.
		aDescription isReadonly
			ifTrue: [ stream space; nextPutAll: 'readonly' ].
		aDescription isRequired
			ifTrue: [ stream space; nextPutAll: 'required' ] ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/23/2005 07:29'!
renderContainer: aDescription
	html divClass: 'container' with: [ super renderContainer: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 14:23'!
renderEditor: aDescription
	html 
		divClass: 'editor'
		with: [ super renderEditor: aDescription ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/23/2005 07:28'!
renderElement: aDescription
	self renderComment: aDescription.
	html 
		divClass: (self cssClass: 'element' modificators: aDescription)
		with: [ super renderElement: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 14:23'!
renderLabel: aDescription
	html 
		divClass: 'label'
		with: [ super renderLabel: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 14:38'!
renderSpacer: aDescription
	html divClass: 'spacer' with: nil.! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 14:23'!
renderViewer: aDescription
	html 
		divClass: 'viewer'
		with: [ super renderViewer: aDescription ].! !

!MARenderer class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 21:02'!
in: aComponent on: aRenderer
	^self new
		component: aComponent;
		html: aRenderer;
		yourself.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
component
	^component! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
component: aComponent
	component := aComponent! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
html
	^html! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
html: aRenderer
	html := aRenderer! !

!MARenderer methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 22:13'!
initialize
	super initialize.
	self readonly: false.! !

!MARenderer methodsFor: 'testing' stamp: 'lr 3/10/2005 21:18'!
isReadonly
	^self readonly.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:17'!
readonly
	^readonly! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:17'!
readonly: aBoolean
	readonly := aBoolean! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/23/2005 07:27'!
renderComment: aDescription
	aDescription hasComment
		ifTrue: [ html attributeAt: 'title' put: aDescription comment ].! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:50'!
renderContainer: aDescription
	self renderWidget: aDescription.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:17'!
renderEditor: aDescription
	self component renderEditorOn: html.! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/14/2005 14:37'!
renderElement: aDescription
	self renderLabel: aDescription.
	self renderSpacer: aDescription.
	self renderWidget: aDescription.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/13/2005 18:06'!
renderLabel: aDescription
	self component renderLabelOn: html.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/14/2005 14:37'!
renderSpacer: aDescription! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:17'!
renderViewer: aDescription
	self component renderViewerOn: html.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:51'!
renderWidget: aDescription
	(self isReadonly or: [ aDescription isReadonly ])
		ifTrue: [ self renderViewer: aDescription ]
		ifFalse: [ self renderEditor: aDescription ].! !

!MARenderer methodsFor: 'visiting' stamp: 'lr 3/10/2005 22:12'!
visit: aDescription
	aDescription acceptRenderer: self.! !

MARenderer subclass: #MATableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:55'!
renderContainer: aDescription
	html table: [ super renderWidget: aDescription ].
! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/23/2005 07:29'!
renderElement: aDescription
	self renderComment: aDescription.
	html tableRow: [ super renderElement: aDescription ].
! !

!MATableRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:22'!
renderLabel: aDescription
	html tableHeading: [ super renderLabel: aDescription ].! !

!MATableRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:30'!
renderWidget: aDescription
	html tableData: [ super renderWidget: aDescription ].! !

!Object methodsFor: '*Magritte-Seaside' stamp: 'lr 3/15/2005 15:55'!
asComponent
	"Return a generic Seaside component of the receiver."

	^self description asComponentOn: self.! !

!MATimeStampDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/11/2005 23:05'!
defaultComponentClass
	^MATimeStampInputComponent! !

!MATextDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATextAreaComponent! !

!MADateDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MADateInputComponent! !

!MATableDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/15/2005 09:00'!
defaultComponentClass
	^MATableComponent! !

!MAComposedDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/21/2005 20:06'!
defaultComponentClass
	^MAComposedComponent! !

!MAComposedDescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:09'!
acceptRenderer: aRenderer
	aRenderer renderContainer: self.! !

!MAOptionsDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/11/2005 23:22'!
defaultComponentClass
	^MASelectListComponent! !

!MABinaryDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:35'!
defaultComponentClass
	^MAFileUploadComponent! !

!MADescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 22:25'!
defaultComponentClass
	self subclassResponsibility! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:05'!
acceptRenderer: aRenderer
	self subclassResponsibility.! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/9/2005 22:28'!
asComponentOn: anObject
	^self componentClass model: anObject description: self.! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
componentClass
	^self propertyAt: #componentClass ifAbsent: [ self class defaultComponentClass ].! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
componentClass: aClass
	^self propertyAt: #componentClass put: aClass.! !

WADecoration subclass: #MAValidationDecoration
	instanceVariableNames: 'exceptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAValidationDecoration methodsFor: 'accessing-configuration' stamp: 'lr 3/21/2005 13:43'!
defaultExceptionSet
	^MAError! !

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 3/13/2005 17:50'!
exceptions
	^exceptions! !

!MAValidationDecoration methodsFor: 'accessing' stamp: 'lr 3/11/2005 17:17'!
exceptions: aCollection
	exceptions := aCollection! !

!MAValidationDecoration methodsFor: 'testing' stamp: 'lr 3/13/2005 20:05'!
hasExceptions
	^self exceptions isEmptyOrNil not.! !

!MAValidationDecoration methodsFor: 'initialization' stamp: 'lr 3/14/2005 16:53'!
initialize
	super initialize.
	self exceptions: Array new.! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 3/13/2005 17:48'!
processChildCallbacks: aStream
	self wrapInValidationHandlerDo: [ super processChildCallbacks: aStream ].! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 3/14/2005 16:46'!
renderContentOn: html
	self hasExceptions
		ifTrue: [ self renderExceptionsOn: html ].
	self renderOwnerOn: html.! !

!MAValidationDecoration methodsFor: 'rendering' stamp: 'lr 3/14/2005 16:55'!
renderExceptionsOn: html
	html divClass: 'exceptions' with: [
		self exceptions do: [ :each |
			html divClass: 'exception' with: each messageText ] ].
	self exceptions: Array new.! !

!MAValidationDecoration methodsFor: 'private' stamp: 'lr 3/21/2005 13:51'!
wrapInValidationHandlerDo: aBlock
	aBlock
		on: self defaultExceptionSet
		do: [ :error | 
			self exceptions: (self exceptions copyWith: error).
			error isResumable ifTrue: [ error resume ] ].! !

!MAPasswordDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATextPasswordComponent! !

!MAStringDescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MATextInputComponent! !
MAComponent initialize!
